(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_size ctx ppf = function
  | (u_l, u_l0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    Upervasives_print.printer_length Og_precedence.Ck_tuple_item ppf u_l;
    Format.fprintf ppf "%,,@ ";
    Upervasives_print.printer_length Og_precedence.Ck_tuple_item ppf u_l0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_key ctx ppf = function
  | u_e -> Umatrix_index_print.printer_element ctx ppf u_e
;;

let printer_value ctx ppf = function
  | u_i -> Umatrix_index_print.printer_index ctx ppf u_i
;;

let printer_t ctx ppf = function
  | t ->
    (fun s_k_u_t ->
     Ugen_numbering_hashtbl_print.printer_t printer_size printer_key
       ctx
       ppf
       s_k_u_t)
      (Umatrix_hashtbl.of_t
      t)
;;

(* Defining top printers. *)

let print_size ppf = printer_size Og_precedence.Ck_toplevel ppf
;;

let print_key ppf = printer_key Og_precedence.Ck_toplevel ppf
;;

let print_value ppf = printer_value Og_precedence.Ck_toplevel ppf
;;

let print_t ppf = printer_t Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
