(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: monitor.mli,v 1.8 2017/05/31 16:38:15 fclement Exp $ *)

open Segmentation_types;;

val interruption : Format.formatter -> unit;;

type 'a sub_zone_report = zone_number * Upervasives.length * 'a;;
type 'a zone_splitting_report =
  zone_number * 'a sub_zone_report * 'a sub_zone_report
;;

val printer_zone_splitting_report :
  ('a, 'a zone_splitting_report) Og_types.printer_lifter
;;

val print_iteration_report :
  ('a, Unatural.t * 'a) Og_types.top_printer_lifter
;;

val total_allocated_memory : unit -> float * string;;
