(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2009-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: vector_types.ml,v 1.10 2017/05/31 16:38:16 fclement Exp $ *)

let v_qual = Upervasives.qualify "Vector";;

let v_failwith = Upervasives.failwith_qual v_qual;;

open Vector_types_spec;;

module Make =
  functor (D : DIMENSION) ->
struct
  type 'a t = 'a array;;
  
  let to_vector a =
    if Uarray.length a <> D.get_dim () then
      v_failwith "of_array" "wrong length" else
    a
  ;;
  
  external of_vector : 'a t -> 'a array = "%identity";;
end
;;
