(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: hashtbl_print.ml,v 1.9 2017/05/31 15:24:07 fclement Exp $ *)

let printer_statistics ctx ppf = function
  | {
      Hashtbl.num_bindings = i;
      Hashtbl.num_buckets = i0;
      Hashtbl.max_bucket_length = i1;
      Hashtbl.bucket_histogram = i_a;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,Hashtbl.@,";
    Format.fprintf ppf "%,@[<hv 2>num_bindings =@ ";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>num_buckets =@ ";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>max_bucket_length =@ ";
    Og_printer.printer_Int Og_precedence.Ck_record_field ppf i1;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>bucket_histogram =@ ";
    Og_printer.printer_Array Og_printer.printer_Int
      Og_precedence.Ck_record_field
      ppf
      i_a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_statistics ppf = printer_statistics Og_precedence.Ck_toplevel ppf
;;
