(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_t px_a ctx ppf = function
  | { Uaref.get = f_u_a; Uaref.set = f_a_u; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><get>@,";
    Og_printer_xml.printer_xml_Fun Og_printer_xml.printer_xml_Unit px_a
      Og_precedence.Ck_record_field
      ppf
      f_u_a;
    Format.fprintf ppf "%,@;<0 -2></get>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><set>@,";
    Og_printer_xml.printer_xml_Fun px_a Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_a_u;
    Format.fprintf ppf "%,@;<0 -2></set>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_aref px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

let printer_xml_aref_list px_a ctx ppf = function
  | {
      Uaref.get_list = f_u_a_l;
      Uaref.add_item = f_a_u;
      Uaref.clear_list = f_u_u;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><get_list>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      (Og_printer_xml.printer_xml_List px_a)
      Og_precedence.Ck_record_field
      ppf
      f_u_a_l;
    Format.fprintf ppf "%,@;<0 -2></get_list>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><add_item>@,";
    Og_printer_xml.printer_xml_Fun px_a Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_a_u;
    Format.fprintf ppf "%,@;<0 -2></add_item>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><clear_list>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,@;<0 -2></clear_list>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_aref_name ctx ppf = function
  | s -> Og_printer_xml.printer_xml_String ctx ppf s
;;

let printer_xml_aref_spec _px_a _px_b ctx ppf = function
  | a -> Og_printer_xml.printer_xml_Abstract ctx ppf a
;;

let printer_xml_bounds_spec px_b ctx ppf = function
  | {
      Uaref.min = b_o;
      Uaref.max = b_o0;
      Uaref.compare = f_b_f_b_i;
      Uaref.string_of = f_b_s;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><min>@,";
    Og_printer_xml.printer_xml_Option px_b
      Og_precedence.Ck_record_field
      ppf
      b_o;
    Format.fprintf ppf "%,@;<0 -2></min>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><max>@,";
    Og_printer_xml.printer_xml_Option px_b
      Og_precedence.Ck_record_field
      ppf
      b_o0;
    Format.fprintf ppf "%,@;<0 -2></max>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><compare>@,";
    Og_printer_xml.printer_xml_Fun
      px_b
      (Og_printer_xml.printer_xml_Fun px_b Og_printer_xml.printer_xml_Int)
      Og_precedence.Ck_record_field
      ppf
      f_b_f_b_i;
    Format.fprintf ppf "%,@;<0 -2></compare>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><string_of>@,";
    Og_printer_xml.printer_xml_Fun px_b Og_printer_xml.printer_xml_String
      Og_precedence.Ck_record_field
      ppf
      f_b_s;
    Format.fprintf ppf "%,@;<0 -2></string_of>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_flag ctx ppf = function
  | {
      Uaref.get_flag = f_u_b;
      Uaref.set_flag = f_u_u;
      Uaref.unset_flag = f_u_u0;
    } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><get_flag>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></get_flag>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><set_flag>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,@;<0 -2></set_flag>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><unset_flag>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u0;
    Format.fprintf ppf "%,@;<0 -2></unset_flag>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

let printer_xml_tflag ctx ppf = function
  | { Uaref.get_tflag = f_u_b; Uaref.toggle_tflag = f_u_u; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><get_tflag>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Bool
      Og_precedence.Ck_record_field
      ppf
      f_u_b;
    Format.fprintf ppf "%,@;<0 -2></get_tflag>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><toggle_tflag>@,";
    Og_printer_xml.printer_xml_Fun
      Og_printer_xml.printer_xml_Unit
      Og_printer_xml.printer_xml_Unit
      Og_precedence.Ck_record_field
      ppf
      f_u_u;
    Format.fprintf ppf "%,@;<0 -2></toggle_tflag>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"
;;

(* Defining top printers. *)

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_aref px_a ppf =
  printer_xml_aref px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_aref_list px_a ppf =
  printer_xml_aref_list px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_aref_name ppf =
  printer_xml_aref_name Og_precedence.Ck_toplevel ppf
;;

let print_xml_aref_spec px_a px_b ppf =
  printer_xml_aref_spec px_a px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_bounds_spec px_b ppf =
  printer_xml_bounds_spec px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_flag ppf = printer_xml_flag Og_precedence.Ck_toplevel ppf
;;

let print_xml_tflag ppf = printer_xml_tflag Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
