(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_arrow_number ctx ppf = function
  | u_a -> Udelayed_dgraph_types_print.printer_arrow_number ctx ppf u_a
;;

let printer_delayed_image pp_b ctx ppf = function
  | b_u_d ->
    Udelayed_dgraph_types_print.printer_delayed_image pp_b ctx ppf b_u_d
;;

let printer_delayed_arrow pp_a pp_b ctx ppf = function
  | a_b_u_d ->
    Udelayed_dgraph_types_print.printer_delayed_arrow pp_a pp_b
      ctx
      ppf
      a_b_u_d
;;

let rec printer_t pp_a pp_b pp_c ctx ppf = function
  | a_b_c_u_t ->
    Udelayed_dgraph_types_print.printer_t pp_a pp_b pp_c ctx ppf a_b_c_u_t

and printer_delayed_dgraph pp_a pp_b pp_c ctx ppf = function
  | a_b_c_t -> printer_t pp_a pp_b pp_c ctx ppf a_b_c_t
;;

(* Defining top printers. *)

let print_arrow_number ppf =
  printer_arrow_number Og_precedence.Ck_toplevel ppf
;;

let print_delayed_image pp_b ppf =
  printer_delayed_image pp_b Og_precedence.Ck_toplevel ppf
;;

let print_delayed_arrow pp_a pp_b ppf =
  printer_delayed_arrow pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b pp_c ppf =
  printer_t pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf

and print_delayed_dgraph pp_a pp_b pp_c ppf =
  printer_delayed_dgraph pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
