(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_index px_a ctx ppf = function
  | a_u_i -> Ugraph_types_print_xml.printer_xml_index px_a ctx ppf a_u_i

and printer_xml_uindex px_a ctx ppf = function
  | a_u_u -> Ugraph_types_print_xml.printer_xml_uindex px_a ctx ppf a_u_u
;;

let printer_xml_domain px_a ctx ppf = function
  | a_u_d -> Ugraph_types_print_xml.printer_xml_domain px_a ctx ppf a_u_d

and printer_xml_sub_domain px_a ctx ppf = function
  | a_u_n ->
    Unonempty_set_print_xml.printer_xml_nonempty_subset px_a ctx ppf a_u_n
;;

let printer_xml_images px_b ctx ppf = function
  | b_u_i -> Ugraph_types_print_xml.printer_xml_images px_b ctx ppf b_u_i
;;

let rec printer_xml_t px_a px_b ctx ppf = function
  | a_b_u_t -> Ugraph_types_print_xml.printer_xml_t px_a px_b ctx ppf a_b_u_t

and printer_xml_graph px_a px_b ctx ppf = function
  | a_b_t -> printer_xml_t px_a px_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_xml_index px_a ppf =
  printer_xml_index px_a Og_precedence.Ck_toplevel ppf

and print_xml_uindex px_a ppf =
  printer_xml_uindex px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_domain px_a ppf =
  printer_xml_domain px_a Og_precedence.Ck_toplevel ppf

and print_xml_sub_domain px_a ppf =
  printer_xml_sub_domain px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_images px_b ppf =
  printer_xml_images px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a px_b ppf =
  printer_xml_t px_a px_b Og_precedence.Ck_toplevel ppf

and print_xml_graph px_a px_b ppf =
  printer_xml_graph px_a px_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
