(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_index px_a ctx ppf = function
  | a_u_i -> Unonempty_set_print_xml.printer_xml_index px_a ctx ppf a_u_i

and printer_xml_uindex px_a ctx ppf = function
  | a_u_u -> Unonempty_set_print_xml.printer_xml_uindex px_a ctx ppf a_u_u
;;

let printer_xml_domain px_a ctx ppf = function
  | a_u_t -> Unonempty_set_print_xml.printer_xml_t px_a ctx ppf a_u_t
;;

let printer_xml_images px_b ctx ppf = function
  | Ugraph_types.Constant b ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,";
    Format.fprintf ppf "%,Constant";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    px_b Og_precedence.Ck_argument ppf b;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Ugraph_types.Images b_a ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Images";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    Og_printer_xml.printer_xml_Array px_b Og_precedence.Ck_argument ppf b_a;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let rec printer_xml_t px_a px_b ctx ppf = function
  | { Ugraph_types.domain = a_d; Ugraph_types.images = b_i; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><domain>@,";
    printer_xml_domain px_a Og_precedence.Ck_record_field ppf a_d;
    Format.fprintf ppf "%,@;<0 -2></domain>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><images>@,";
    printer_xml_images px_b Og_precedence.Ck_record_field ppf b_i;
    Format.fprintf ppf "%,@;<0 -2></images>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_graph px_a px_b ctx ppf = function
  | a_b_t -> printer_xml_t px_a px_b ctx ppf a_b_t
;;

(* Defining top printers. *)

let print_xml_index px_a ppf =
  printer_xml_index px_a Og_precedence.Ck_toplevel ppf

and print_xml_uindex px_a ppf =
  printer_xml_uindex px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_domain px_a ppf =
  printer_xml_domain px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_images px_b ppf =
  printer_xml_images px_b Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a px_b ppf =
  printer_xml_t px_a px_b Og_precedence.Ck_toplevel ppf

and print_xml_graph px_a px_b ppf =
  printer_xml_graph px_a px_b Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
