(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_xml_t px_a ctx ppf = function
  | t ->
    (fun a_a_a ->
     Og_printer_xml.printer_xml_Array (Og_printer_xml.printer_xml_Array px_a)
       ctx
       ppf
       a_a_a)
      (Umatrix_types.of_t
      t)

and printer_xml_matrix px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

let rec printer_xml_length ctx ppf = function
  | u_l -> Uarray_print_xml.printer_xml_length ctx ppf u_l

and printer_xml_index ctx ppf = function
  | u_i -> Uarray_print_xml.printer_xml_index ctx ppf u_i

and printer_xml_line_number ctx ppf = function
  | l -> printer_xml_length ctx ppf l

and printer_xml_column_number ctx ppf = function
  | l -> printer_xml_length ctx ppf l

and printer_xml_line_index ctx ppf = function
  | i -> printer_xml_index ctx ppf i
;;

let printer_xml_size ctx ppf = function
  | (l, c) ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><tuple>@,";
    printer_xml_line_number Og_precedence.Ck_tuple_item ppf l;
    Format.fprintf ppf "%,@,";
    printer_xml_column_number Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@;<0 -2></tuple>@]"
;;

(* Defining top printers. *)

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_matrix px_a ppf =
  printer_xml_matrix px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf

and print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf

and print_xml_line_number ppf =
  printer_xml_line_number Og_precedence.Ck_toplevel ppf

and print_xml_column_number ppf =
  printer_xml_column_number Og_precedence.Ck_toplevel ppf

and print_xml_line_index ppf =
  printer_xml_line_index Og_precedence.Ck_toplevel ppf
;;

let print_xml_size ppf = printer_xml_size Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
