(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_uindex pp_a ctx ppf = function
  | a_u_u -> Unonempty_set_types_print.printer_uindex pp_a ctx ppf a_u_u
;;

let printer_index pp_a ctx ppf = function
  | a_u_i -> Unonempty_set_types_print.printer_index pp_a ctx ppf a_u_i
;;

let rec printer_t pp_a ctx ppf = function
  | a_u_t0 -> Unonempty_set_types_print.printer_t pp_a ctx ppf a_u_t0

and printer_nonempty_set pp_a ctx ppf = function
  | a_t -> printer_t pp_a ctx ppf a_t
;;

let printer_nonempty_subset pp_a ctx ppf = function
  | {
      Unonempty_set.support = a_t;
      Unonempty_set.indices = a_i_a;
      Unonempty_set.nonempty_set = a_t0;
    } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>support =";
    printer_t pp_a Og_precedence.Ck_record_field ppf a_t;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>indices =";
    Og_printer.printer_Array (printer_index pp_a)
      Og_precedence.Ck_record_field
      ppf
      a_i_a;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>nonempty_set =";
    printer_t pp_a Og_precedence.Ck_record_field ppf a_t0;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

let printer_dichotomy pp_a ctx ppf = function
  | (a_n, a_n0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_nonempty_subset pp_a Og_precedence.Ck_tuple_item ppf a_n;
    Format.fprintf ppf "%,,@ ";
    printer_nonempty_subset pp_a Og_precedence.Ck_tuple_item ppf a_n0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

(* Defining top printers. *)

let print_uindex pp_a ppf = printer_uindex pp_a Og_precedence.Ck_toplevel ppf
;;

let print_index pp_a ppf = printer_index pp_a Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a ppf = printer_t pp_a Og_precedence.Ck_toplevel ppf

and print_nonempty_set pp_a ppf =
  printer_nonempty_set pp_a Og_precedence.Ck_toplevel ppf
;;

let print_nonempty_subset pp_a ppf =
  printer_nonempty_subset pp_a Og_precedence.Ck_toplevel ppf
;;

let print_dichotomy pp_a ppf =
  printer_dichotomy pp_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
