(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let rec printer_t ctx ppf = function
  | u_t -> Uoption_key_types_print.printer_t ctx ppf u_t

and printer_option_key ctx ppf = function | t -> printer_t ctx ppf t
;;

let rec printer_long_option_key ctx ppf = function | t -> printer_t ctx ppf t

and printer_short_option_key ctx ppf = function | t -> printer_t ctx ppf t

and printer_short_option_key_status ctx ppf = function
  | Uoption_key.Automatic ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,Automatic"
  | Uoption_key.Short s ->
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>Short";
    printer_short_option_key Og_precedence.Ck_argument ppf s;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"

and printer_option_keys ctx ppf = function
  | { Uoption_key.long = l; Uoption_key.short = s; } ->
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%, {@ " else
    Format.fprintf ppf "%,@[<hv 2>{@ "; Format.fprintf ppf "%,@[<hv 0>";
    Format.fprintf ppf "%,@[<hv 2>long =";
    printer_long_option_key Og_precedence.Ck_record_field ppf l;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@ ";
    Format.fprintf ppf "%,@[<hv 2>short =";
    printer_short_option_key_status Og_precedence.Ck_record_field ppf s;
    Format.fprintf ppf "%,;@]"; Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument || ctx = Og_precedence.Ck_record_field
      then Format.fprintf ppf "%,@;<1 -2>}" else
    Format.fprintf ppf "%,@;<1 -2>}@]"
;;

(* Defining top printers. *)

let print_t ppf = printer_t Og_precedence.Ck_toplevel ppf

and print_option_key ppf = printer_option_key Og_precedence.Ck_toplevel ppf
;;

let print_long_option_key ppf =
  printer_long_option_key Og_precedence.Ck_toplevel ppf

and print_short_option_key ppf =
  printer_short_option_key Og_precedence.Ck_toplevel ppf

and print_short_option_key_status ppf =
  printer_short_option_key_status Og_precedence.Ck_toplevel ppf

and print_option_keys ppf = printer_option_keys Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
