(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_index ctx ppf = function
  | u_i -> Udynamic_array_print_xml.printer_xml_index ctx ppf u_i
;;

let printer_xml_length ctx ppf = function
  | u_l -> Udynamic_array_print_xml.printer_xml_length ctx ppf u_l
;;

let printer_xml_stamped px_a ctx ppf = function
  | Ustamped_darray.Unset ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Unset";
    Format.fprintf ppf "%,@;<0 -2></lident>@]";
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
  | Ustamped_darray.Valid a ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><constructor>@,";
    Format.fprintf ppf "%,@[<hv 2><lident>@,"; Format.fprintf ppf "%,Valid";
    Format.fprintf ppf "%,@;<0 -2></lident>@]"; Format.fprintf ppf "%,@,";
    px_a Og_precedence.Ck_argument ppf a;
    Format.fprintf ppf "%,@;<0 -2></constructor>@]"
;;

let rec printer_xml_t px_a ctx ppf = function
  | { Ustamped_darray.darray = a_s_u_t; Ustamped_darray.next_unset = i; } ->
    ignore ctx; Format.fprintf ppf "%,@[<hv 2><record>@,";
    Format.fprintf ppf "%,@[<hv 2><darray>@,";
    Udynamic_array_print_xml.printer_xml_t (printer_xml_stamped px_a)
      Og_precedence.Ck_record_field
      ppf
      a_s_u_t;
    Format.fprintf ppf "%,@;<0 -2></darray>@]"; Format.fprintf ppf "%,@,";
    Format.fprintf ppf "%,@[<hv 2><next_unset>@,";
    printer_xml_index Og_precedence.Ck_record_field ppf i;
    Format.fprintf ppf "%,@;<0 -2></next_unset>@]";
    Format.fprintf ppf "%,@;<0 -2></record>@]"

and printer_xml_stamped_darray px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_index ppf = printer_xml_index Og_precedence.Ck_toplevel ppf
;;

let print_xml_length ppf = printer_xml_length Og_precedence.Ck_toplevel ppf
;;

let print_xml_stamped px_a ppf =
  printer_xml_stamped px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_stamped_darray px_a ppf =
  printer_xml_stamped_darray px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
