(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_xml_index px_a ctx ppf = function
  | a_u_t -> Uindex_print_xml.printer_xml_t px_a ctx ppf a_u_t
;;

let printer_xml_indices px_a ctx ppf = function
  | a_u_i -> Uuniverse_types_print_xml.printer_xml_indices px_a ctx ppf a_u_i
;;

let printer_xml_elements px_a ctx ppf = function
  | a_a -> Og_printer_xml.printer_xml_Array px_a ctx ppf a_a
;;

let rec printer_xml_t px_a ctx ppf = function
  | a_u_t -> Uuniverse_types_print_xml.printer_xml_t px_a ctx ppf a_u_t

and printer_xml_universe px_a ctx ppf = function
  | a_t -> printer_xml_t px_a ctx ppf a_t
;;

(* Defining top printers. *)

let print_xml_index px_a ppf =
  printer_xml_index px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_indices px_a ppf =
  printer_xml_indices px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_elements px_a ppf =
  printer_xml_elements px_a Og_precedence.Ck_toplevel ppf
;;

let print_xml_t px_a ppf = printer_xml_t px_a Og_precedence.Ck_toplevel ppf

and print_xml_universe px_a ppf =
  printer_xml_universe px_a Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
