(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: ubuffer.mli,v 1.17 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 More buffer operations} *)

val to_bytes : Buffer.t -> Upervasives.bytes;;
val add_subbytes : Buffer.t -> Upervasives.bytes -> int -> int -> unit

val flush_buffer : out_channel -> Buffer.t -> unit;;

val flush_buffer_on_stdout : Buffer.t -> unit;;
val flush_buffer_on_stderr : Buffer.t -> unit;;
val flush_buffer_on_file : open_flag Ulist.t -> string -> Buffer.t -> unit;;
