(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: udelayed_dgraph_types.mli,v 1.2 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 The private type of delayed dynamic graphs} *)

(** Direct access data structure. *)

type arrow_number = Udynamic_graph.arrow_number;;

type 'b delayed_image =
  | Not_yet_computed
  | Image of 'b
;;

type ('a, 'b) delayed_arrow = ('a, 'b delayed_image) Udynamic_graph.arrow;;

type ('a, 'b, 'c) t = private {
  f : 'c -> arrow_number -> 'a -> 'b;
  graph : ('a, 'b delayed_image) Udynamic_graph.t;
  to_do : arrow_number list;
}
and ('a, 'b, 'c) delayed_dgraph = ('a, 'b, 'c) t
;;

val make :
  ('c -> arrow_number -> 'a -> 'b) -> arrow_number -> 'a -> ('a, 'b, 'c) t
;;

val set_next : ('a, 'b, 'c) t -> 'a -> ('a, 'b, 'c) t;;
val set : ('a, 'b, 'c) t -> arrow_number -> 'a -> ('a, 'b, 'c) t;;

val of_values :
  ('c -> arrow_number -> 'a -> 'b) -> 'a array -> ('a, 'b, 'c) t
;;

val do_it : 'c -> ('a, 'b, 'c) t -> ('a, 'b, 'c) t;;
