(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex.ml,v 1.11 2017/05/31 15:24:06 fclement Exp $*)

(* The phantom type of indices. *)

(* With such a phantom type, there is no risk to accidentally create a wrong
 value, hence there is no need to define the private type only in a dedicated
 module Uindex_types. *)

module Nat = Unatural;;

type 'a t = Nat.t
and 'a index = 'a t
;;

external to_t : Nat.t -> 'a t = "%identity";;
external of_t : 'a t -> Nat.t = "%identity";;

external of_nat : Nat.t -> 'a t = "%identity";;
external to_nat : 'a t -> Nat.t = "%identity";;

let of_int i = of_nat (Nat.of_int i);;

external to_int : 'a t -> int = "%identity";;

let _0_ = Nat._0_
and _1_ = Nat._1_
;;

let succ = Nat.succ
and pred = Nat.pred
;;

let incr r = r := succ !r
and decr r = r := pred !r
;;
