(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: unatural_types.ml,v 1.14 2017/05/31 15:24:06 fclement Exp $ *)

(* The private type of natural numbers. *)

let failwith fun_name msg =
  Pervasives.failwith (Printf.sprintf "Unatural.%s: %s" fun_name msg)
;;

type t = int
and natural = t
;;

let to_t i =
  if i >= 0 then i else
  failwith "of_int" (Printf.sprintf "negative argument (%d)" i)
;;

external of_t : t -> int = "%identity";;
