(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2004-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: upositive_rational_range.mli,v 1.11 2017/05/31 15:24:06 fclement Exp $ *)

(** {3 Operations on positive rational number ranges} *)

type nonempty_range = Upositive_rational_range_types.nonempty_range = private
  {
   left : Upositive_rational.t;
   right : Upositive_rational.t;
  }
and t = Upositive_rational_range_types.t =
  | Empty
  | Nonempty of nonempty_range
and positive_rational_range = t
;;

val of_rat : Upositive_rational.t -> Upositive_rational.t -> t;;

val intersection : t -> t -> t;;

val project : t -> Upositive_rational.t -> Upositive_rational.t;;
